unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  EditBitmapUtils, Windows, Menus, ExtCtrls, ActnList, LCLType, types, Clipbrd,
  Math, CancelDlgUnit;

type
  TRectEx = record
    Left, Top, Right, Bottom: Extended;
  end;

  { TForm1 }
  TForm1 = class(TForm)
    ActionViewNone: TAction;
    ActionAspectRatioNone: TAction;
    ActionMakeGunya: TAction;
    ActionViewWhiteFrame: TAction;
    ActionViewDarkFrame: TAction;
    ActionMakeRigid: TAction;
    ActionMake: TAction;
    ActionMakeVivid: TAction;
    ActionMakeNegative: TAction;
    ActionMakeMonochrome: TAction;
    ActionSelectAreaFree: TAction;
    Action_SwitchPage: TAction;
    ActionMakeNoEffect: TAction;
    ActionRotateLeft: TAction;
    ActionRotateRight: TAction;
    ActionPaste: TAction;
    ActionCopy: TAction;
    ActionExit: TAction;
    ActionSave: TAction;
    ActionOpen: TAction;
    ActionList1: TActionList;
    ColorDialog_BkgColor: TColorDialog;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItemView: TMenuItem;
    MenuItemSelectArea: TMenuItem;
    MenuItemSave: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem37: TMenuItem;
    MenuItemRotateRight: TMenuItem;
    MenuItemRotateLeft: TMenuItem;
    MenuItemCopy: TMenuItem;
    MenuItemPaste: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItemMake: TMenuItem;
    MenuItemEdit: TMenuItem;
    MenuItemFile: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    PaintBoxDst: TPaintBox;
    PaintBoxSrc: TPaintBox;
    SaveDialog1: TSaveDialog;
    Shape_CutOut: TShape;
    StatusBar1: TStatusBar;
    TabSheetDst: TTabSheet;
    TabSheetSrc: TTabSheet;
    procedure ActionSelectAreaFreeExecute(Sender: TObject);
    procedure ActionCopyExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionMakeExecute(Sender: TObject);
    procedure ActionOpenExecute(Sender: TObject);
    procedure ActionPasteExecute(Sender: TObject);
    procedure ActionRotateLeftExecute(Sender: TObject);
    procedure ActionRotateRightExecute(Sender: TObject);
    procedure ActionSaveExecute(Sender: TObject);
    procedure ActionViewExecute(Sender: TObject);
    procedure Action_SwitchPageExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuItemEditClick(Sender: TObject);
    procedure MenuItemFileClick(Sender: TObject);
    procedure MenuItemMakeClick(Sender: TObject);
    procedure PaintBoxDstDblClick(Sender: TObject);
    procedure PaintBoxDstPaint(Sender: TObject);
    procedure PaintBoxSrcDblClick(Sender: TObject);
    procedure PaintBoxSrcPaint(Sender: TObject);
    procedure Shape_CutOutMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape_CutOutMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Shape_CutOutMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    FSrcBitmap: EditBitmapUtils.TBitmap32;
    FDstBitmap: EditBitmapUtils.TBitmap32;
    FMouseDown_CursorPoint: TPoint; // マウス押下時にスクリーン座標で保存
    FCutOutRatioRect: TRectEx; // 切出し枠を元画像の比率（-1.0 ～ +1.0）で指定
    FMouseDown_CutOutRatioRect: TRectEx; // マウス押下時に保存
    function CalcDrawRect(DstRect, SrcRect: TRect): TRect;
    procedure Init_CutOutRatioRect_by_AspectRatio;
  protected
    procedure DoEffect(EffectIndex: Integer);
    procedure WMUser_0(var Message: TMessage); message WM_USER + 0;
    procedure DoEffect_Nothing;
    procedure DoEffect_Monochrome;
    procedure DoEffect_Negative;
    procedure DoEffect_Rigid;
    procedure DoEffect_Gunya;
    procedure DoDarkFrame(Bitmap: TBitmap32);
    procedure DoWhiteFrame(Bitmap: TBitmap32);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSrcBitmap := EditBitmapUtils.TBitmap32.Create;
  FDstBitmap := EditBitmapUtils.TBitmap32.Create;

  Caption := Application.Title;
  ColorDialog_BkgColor.Color := clWhite;
  TabSheetSrc.Show;

  // プロパティに直に日本語で書込んでも良いのですが、何となく？
  MenuItemFile.Caption := 'ファイル(&F)';
  ActionOpen.Caption := '開く(&O)';
  ActionSave.Caption := '保存(&S)';
  ActionExit.Caption := '終了(&X)';
  MenuItemEdit.Caption := '編集(&E)';
  ActionCopy.Caption := 'コピー(&C)';
  ActionPaste.Caption := '貼付け(&P)';
  ActionRotateRight.Caption := '右回転(&R)';
  ActionRotateLeft.Caption := '左回転(&L)';
  MenuItemSelectArea.Caption := '切出し枠(&S)';
  ActionSelectAreaFree.Caption := '自由選択(&F)';
  MenuItemMake.Caption := '画像処理の実行(&M)';
  ActionMakeNoEffect.Caption := 'コピーするだけ';
  ActionMakeMonochrome.Caption := '白黒(&M)';
  ActionMakeNegative.Caption := '反転(&N)';
  ActionMakeRigid.Caption := 'くっきり(&R)';
  ActionMakeVivid.Caption := '鮮やか(&V)';
  ActionMakeGunya.Caption := 'ぐにゃ(&G)';
  MenuItemView.Caption := '処理後の表示(&V)';
  ActionViewDarkFrame.Caption := '周囲を暗くする(&D)';
  ActionViewWhiteFrame.Caption := '周囲を白くする(&W)';

  TabSheetSrc.Caption := '処理前';
  TabSheetDst.Caption := '処理後';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FSrcBitmap.Free;
  FDstBitmap.Free;
end;

procedure TForm1.MenuItemEditClick(Sender: TObject);
begin
  // メインメニュー[Edit]のサブメニュー項目を
  // 状態に応じて有効／無効にする
  MenuItemCopy.Enabled := FDstBitmap.NotEmpty;
  MenuItemPaste.Enabled := ClipBoard.HasPictureFormat;
  MenuItemRotateRight.Enabled := FSrcBitmap.NotEmpty;
  MenuItemRotateLeft.Enabled  := FSrcBitmap.NotEmpty;
end;

procedure TForm1.MenuItemFileClick(Sender: TObject);
begin
  // メインメニュー[File]のサブメニュー項目を
  // 状態に応じて有効／無効にする
  MenuItemSave.Enabled := FDstBitmap.NotEmpty;
end;

procedure TForm1.MenuItemMakeClick(Sender: TObject);
var
  I: Integer;
begin
  // メインメニュー[Make]のサブメニュー項目を
  // 状態に応じて有効／無効にする
  for I := 0 to MenuItemMake.Count - 1 do
    MenuItemMake.Items[I].Enabled := FSrcBitmap.NotEmpty;
end;

procedure TForm1.ActionOpenExecute(Sender: TObject);
var
  FileName: string;
begin
  if OpenDialog1.Execute then
  begin
    //LoadFromFile(OpenDialog1.FileName);
    // 実行環境によっては、次にダイアログを開く際に
    // ファイル名の欄に "パス＋ファイル名" で表示される問題を回避
    FileName := OpenDialog1.FileName;
    OpenDialog1.InitialDir := ExtractFilePath(FileName);
    OpenDialog1.FileName   := ExtractFileName(FileName);
    SaveDialog1.InitialDir := OpenDialog1.InitialDir;
    SaveDialog1.FileName   := OpenDialog1.FileName;

    Screen.Cursor := crHourGlass;
    try
      FSrcBitmap.LoadFromFile(FileName);
      Init_CutOutRatioRect_by_AspectRatio;
    finally
      Screen.Cursor := crDefault;
    end;

    TabSheetSrc.Show;
    PaintBoxSrc.Invalidate;
  end;
end;

procedure TForm1.ActionSaveExecute(Sender: TObject);
var
  SaveBitmap: TBitmap32;
begin
  if FDstBitmap.NotEmpty then
  begin
    if SaveDialog1.Execute then
    begin
      if ActionViewDarkFrame.Checked then
      begin
        SaveBitmap := FDstBitmap.Duplicate;
        DoDarkFrame(SaveBitmap);
      end
      else if ActionViewWhiteFrame.Checked then
      begin
        SaveBitmap := FDstBitmap.Duplicate;
        DoWhiteFrame(SaveBitmap);
      end
      else
        SaveBitmap := FDstBitmap;

      SaveBitmap.SaveAsJPGFile(SaveDialog1.FileName, 90);
      if SaveBitmap <> FDstBitmap then
        SaveBitmap.Free;
    end;
  end
  else
    ShowMessage('Save Failure: DstBitmap is Empty');
end;

procedure TForm1.ActionViewExecute(Sender: TObject);
begin
  if Sender is TAction then
    TAction(Sender).Checked := TRUE;

  if FDstBitmap.NotEmpty then
  begin
    TabSheetDst.Show;
    PaintBoxDst.Invalidate;
  end;
end;

procedure TForm1.ActionExitExecute(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.ActionCopyExecute(Sender: TObject);
var
  Picture: TPicture;
begin
  if FDstBitmap.NotEmpty then
  begin
    Picture := TPicture.Create;
    try
      Picture.Bitmap.Width  := FDstBitmap.Width;
      Picture.Bitmap.Height := FDstBitmap.Height;
      Picture.Bitmap.PixelFormat := pf32bit;
      FDstBitmap.PaintTo(Picture.Bitmap.Canvas, FDstBitmap.Rect);

      // なぜかこれをやらないとコピーが真っ黒になる？
      Picture.Bitmap.Canvas.Pixels[0, 0] := Picture.Bitmap.Canvas.Pixels[0, 0];

      Clipboard.Assign(Picture.Bitmap);
    finally
      Picture.Free;
    end;
  end;
end;

procedure TForm1.ActionPasteExecute(Sender: TObject);
var
  ClipboardFormat: TClipboardFormat;
  Picture: TPicture;
begin
  ClipboardFormat := Clipboard.FindPictureFormatID;
  if ClipboardFormat <> 0 then
  begin
    Picture := TPicture.Create;
    try
      Picture.LoadFromClipboardFormat(ClipboardFormat);
      if Assigned(Picture.Graphic)then
      begin
        FSrcBitmap.CreateNew(Picture.Graphic.Width, Picture.Graphic.Height);
        FSrcBitmap.Canvas.Draw(0, 0, Picture.Graphic);
        FDstBitmap.Clear;
        TabSheetSrc.Show;
        PaintBoxSrc.Invalidate;
      end
      else
        ShowMessage('Picture.Graphic is Empty');
    finally
      Picture.Free;
    end;
  end;
  Init_CutOutRatioRect_by_AspectRatio;
end;

procedure TForm1.ActionRotateLeftExecute(Sender: TObject);
var
  X, Y: Integer;
  TmpBitmap: EditBitmapUtils.TBitmap32;
begin
  if FSrcBitmap.NotEmpty then
  begin
    Screen.Cursor := crHourGlass;
    try
      TmpBitmap := FSrcBitmap.Duplicate;
      try
        FSrcBitmap.CreateNew(TmpBitmap.Height, TmpBitmap.Width);

        for Y := 0 to TmpBitmap.Height - 1 do
        for X := 0 to TmpBitmap.Width - 1 do
          FSrcBitmap.Pixel[Y, FSrcBitmap.Height - X - 1]^ := TmpBitmap.Pixel[X, Y]^;

      finally
        TmpBitmap.Free;
      end;
    finally
      Screen.Cursor := crDefault;
    end;

    FDstBitmap.Clear;
    Init_CutOutRatioRect_by_AspectRatio;

    TabSheetSrc.Show;
    TabSheetSrc.Invalidate;
  end;
end;

procedure TForm1.ActionRotateRightExecute(Sender: TObject);
var
  X, Y: Integer;
  TmpBitmap: EditBitmapUtils.TBitmap32;
begin
  if FSrcBitmap.NotEmpty then
  begin
    Screen.Cursor := crHourGlass;
    try
      TmpBitmap := FSrcBitmap.Duplicate;
      try
        FSrcBitmap.CreateNew(TmpBitmap.Height, TmpBitmap.Width);

        for Y := 0 to TmpBitmap.Height - 1 do
        for X := 0 to TmpBitmap.Width - 1 do
          FSrcBitmap.Pixel[FSrcBitmap.Width - Y - 1, X]^ := TmpBitmap.Pixel[X, Y]^;

      finally
        TmpBitmap.Free;
      end;
    finally
      Screen.Cursor := crDefault;
    end;

    FDstBitmap.Clear;
    Init_CutOutRatioRect_by_AspectRatio;

    TabSheetSrc.Show;
    TabSheetSrc.Invalidate;
  end;
end;

procedure TForm1.ActionSelectAreaFreeExecute(Sender: TObject);
begin
  if(Sender is TAction) and
    (TAction(Sender).Checked = FALSE) then
  begin
    TAction(Sender).Checked := TRUE;
    Init_CutOutRatioRect_by_AspectRatio;
    if FSrcBitmap.NotEmpty then
    begin
      PageControl1.ActivePage := TabSheetSrc;
      PaintBoxSrc.Invalidate;
    end;
  end;
end;

procedure TForm1.Action_SwitchPageExecute(Sender: TObject);
begin
  begin
    if PageControl1.ActivePage = TabSheetDst then
      TabSheetSrc.Show
    else
      TabSheetDst.Show;
  end;
end;

procedure TForm1.Init_CutOutRatioRect_by_AspectRatio;
begin
  // default値は元ビットマップの端から端まで最大領域
  FCutOutRatioRect.Left   := -1;
  FCutOutRatioRect.Right  := 1;
  FCutOutRatioRect.Top    := -1;
  FCutOutRatioRect.Bottom := 1;

  Shape_CutOut.Visible := FSrcBitmap.NotEmpty and ActionSelectAreaFree.Checked;
end;

function TForm1.CalcDrawRect(DstRect, SrcRect: TRect): TRect;
var
  DstSize, SrcSize: TSize;
  I: Integer;
begin
  DstSize.cx := DstRect.Right  - DstRect.Left;
  DstSize.cy := DstRect.Bottom - DstRect.Top;
  SrcSize.cx := SrcRect.Right  - SrcRect.Left;
  SrcSize.cy := SrcRect.Bottom - SrcRect.Top;
  if(DstSize.cx > 0)and(DstSize.cy > 0)and(SrcSize.cx > 0)and(SrcSize.cy > 0)then
  begin
    if(DstSize.cx * SrcSize.cy) > (DstSize.cy * SrcSize.cx) then
    begin
      // 上下ぴったり、左右に余白
      // 描画の幅を計算
      I := DstSize.cy * SrcSize.cx div SrcSize.cy;
      Result.Left   := (DstRect.Left + DstRect.Right - I) div 2;
      Result.Right  := Result.Left + I;
      Result.Top    := DstRect.Top;
      Result.Bottom := DstRect.Bottom;
    end
    else
    begin
      // 左右ぴったり、上下に余白
      // 描画の高さを計算
      I := DstSize.cx * SrcSize.cy div SrcSize.cx;
      Result.Top    := (DstRect.Top + DstRect.Bottom - I) div 2;
      Result.Bottom := Result.Top + I;
      Result.Left   := DstRect.Left;
      Result.Right  := DstRect.Right;
    end;
  end
  else
  begin
    Result := Classes.Rect(0, 0, 0, 0);
  end;
end;

procedure TForm1.PaintBoxSrcPaint(Sender: TObject);
var
  PaintSize: TSize;
  PaintRect: TRect;
begin
  with PaintBoxSrc do
  begin
    Canvas.Brush.Color := ColorDialog_BkgColor.Color;
    Canvas.FillRect(ClientRect);
  end;

  if FSrcBitmap.NotEmpty then
  begin
    PaintRect := CalcDrawRect(PaintBoxSrc.ClientRect, FSrcBitmap.Rect);
    FSrcBitmap.PaintTo(PaintBoxSrc.Canvas, PaintRect);

    if Shape_CutOut.Visible then
    begin
      PaintSize.cx := PaintRect.Right - PaintRect.Left;
      PaintSize.cy := PaintRect.Bottom - PaintRect.Top;

      Shape_CutOut.SetBounds(
        Round((PaintRect.Left + PaintRect.Right + PaintSize.cx * FCutOutRatioRect.Left) / 2),
        Round((PaintRect.Top + PaintRect.Bottom + PaintSize.cy * FCutOutRatioRect.Top) / 2),
        Round(PaintSize.cx * (FCutOutRatioRect.Right - FCutOutRatioRect.Left) / 2),
        Round(PaintSize.cy * (FCutOutRatioRect.Bottom - FCutOutRatioRect.Top) / 2));
    end;
  end;
end;

procedure TForm1.PaintBoxDstPaint(Sender: TObject);
var
  PaintRect: TRect;
  PaintBitmap: TBitmap32;
begin
  with PaintBoxDst do
  begin
    Canvas.Brush.Color := ColorDialog_BkgColor.Color;
    Canvas.FillRect(ClientRect);
  end;

  if FDstBitmap.NotEmpty then
  begin
    PaintRect := CalcDrawRect(PaintBoxDst.ClientRect, FDstBitmap.Rect);
    if ActionViewDarkFrame.Checked then
    begin
      PaintBitmap := FDstBitmap.Duplicate;
      DoDarkFrame(PaintBitmap);
    end
    else if ActionViewWhiteFrame.Checked then
    begin
      PaintBitmap := FDstBitmap.Duplicate;
      DoWhiteFrame(PaintBitmap);
    end
    else
      PaintBitmap := FDstBitmap;

    PaintBitmap.PaintTo(PaintBoxDst.Canvas, PaintRect);
    if PaintBitmap <> FDstBitmap then
      PaintBitmap.Free;
  end;
end;

procedure TForm1.PaintBoxSrcDblClick(Sender: TObject);
begin
  with FSrcBitmap.Size do
  ShowMessage('SrcBitmap.Size = ' + IntToStr(cx) + ' x ' + IntToStr(cy));
end;

procedure TForm1.PaintBoxDstDblClick(Sender: TObject);
begin
  with FDstBitmap.Size do
  ShowMessage('DstBitmap.Size = ' + IntToStr(cx) + ' x ' + IntToStr(cy));
end;

procedure TForm1.Shape_CutOutMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FMouseDown_CursorPoint := Shape_CutOut.ClientToScreen(Classes.Point(X, Y));
  FMouseDown_CutOutRatioRect := FCutOutRatioRect;

  // 四隅でマウスが押されたら、MouseMoveイベントでサイズ変更処理をするため
  // Tag に記録する
  if(X < 8)and(Y < 8)then
    Shape_CutOut.Tag := 1
  else if(X >= (Shape_CutOut.Width - 8))and(Y < 8)then
    Shape_CutOut.Tag := 3
  else if(X >= (Shape_CutOut.Width - 8))and(Y >= (Shape_CutOut.Height - 8))then
    Shape_CutOut.Tag := 5
  else if(X < 8)and(Y >= (Shape_CutOut.Height - 8))then
    Shape_CutOut.Tag := 7
  else
    Shape_CutOut.Tag := 0;
end;

procedure TForm1.Shape_CutOutMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  I: Integer;
  ptMouse: TPoint;
  dX, dY: Extended;
  DstSize, SrcSize: TSize;
  DstRect: TRect;
  E: Extended;
  NewCutOutRect: TRectEx;
  AspectRatio: TSize;
const
  MIN_SIZE = 0.5; // 全幅（-1.0～+1.0）に対する 0.5 なので 25%
begin
  if Windows.GetKeyState(VK_LBUTTON) >= 0 then
  begin
    // マウス左ボタンがUp状態
    // 四隅ではサイズ変更のカーソルにする
    if(X < 8)and(Y < 8)then
      Shape_CutOut.Cursor := crSizeNWSE
    else if(X < 8)and(Y >= (Shape_CutOut.Height - 8))then
      Shape_CutOut.Cursor := crSizeNESW
    else if(X >= (Shape_CutOut.Width - 8))and(Y >= (Shape_CutOut.Height - 8))then
      Shape_CutOut.Cursor := crSizeNWSE
    else if(X >= (Shape_CutOut.Width - 8))and(Y < 8)then
      Shape_CutOut.Cursor := crSizeNESW
    else
      Shape_CutOut.Cursor := crDefault;
  end
  else
  begin
    // マウス左ボタンがDown状態
    case Shape_CutOut.Tag of
    //0: Shape_CutOut.Cursor := crDefault;
    0: Shape_CutOut.Cursor := crSizeAll;
    1: Shape_CutOut.Cursor := crSizeNWSE;
    3: Shape_CutOut.Cursor := crSizeNESW;
    5: Shape_CutOut.Cursor := crSizeNWSE;
    7: Shape_CutOut.Cursor := crSizeNESW;
    end;

    if FSrcBitmap.NotEmpty then
    begin
      SrcSize := FSrcBitmap.Size;

      // 移動量を算出（スクリーン上のピクセル数）
      ptMouse := Shape_CutOut.ClientToScreen(Classes.Point(X, Y));
      dX := ptMouse.x - FMouseDown_CursorPoint.x;
      dY := ptMouse.y - FMouseDown_CursorPoint.y;

      // 移動量を元画像の倍率に変換
      DstRect := PaintBoxSrc.ClientRect;
      DstSize.cx := DstRect.Right - DstRect.Left;
      DstSize.cy := DstRect.Bottom - DstRect.Top;
      if(DstSize.cx * SrcSize.cy) > (DstSize.cy * SrcSize.cx)then
      begin
        // 縦幅ぴったり、左右に空白
        I := DstSize.cy * SrcSize.cx div SrcSize.cy;
        DstRect.Left := (DstRect.Left + DstRect.Right - I) div 2;
        DstRect.Right := DstRect.Left + I;
      end
      else if(DstSize.cx * SrcSize.cy) < (DstSize.cy * SrcSize.cx)then
      begin
        // 横幅ぴったり、上下に空白
        I := DstSize.cx * SrcSize.cy div SrcSize.cx;
        DstRect.Top := (DstRect.Top + DstRect.Bottom - I) div 2;
        DstRect.Bottom := DstRect.Top + I;
      end;
      DstSize.cx := DstRect.Right - DstRect.Left;
      DstSize.cy := DstRect.Bottom - DstRect.Top;
      dX := dX / DstSize.cx * 2;
      dY := dY / DstSize.cy * 2;

      if Shape_CutOut.Tag = 0 then
      begin
        if (FMouseDown_CutOutRatioRect.Left + dX) < -1 then
          dX := - FMouseDown_CutOutRatioRect.Left - 1
        else if (FMouseDown_CutOutRatioRect.Right + dX) > 1 then
          dX := 1 - FMouseDown_CutOutRatioRect.Right;
        if (FMouseDown_CutOutRatioRect.Top + dY) < -1 then
          dY := - FMouseDown_CutOutRatioRect.Top - 1
        else if (FMouseDown_CutOutRatioRect.Bottom + dY) > 1 then
          dY := 1 - FMouseDown_CutOutRatioRect.Bottom;
        FCutOutRatioRect.Left   := FMouseDown_CutOutRatioRect.Left   + dX;
        FCutOutRatioRect.Top    := FMouseDown_CutOutRatioRect.Top    + dY;
        FCutOutRatioRect.Right  := FMouseDown_CutOutRatioRect.Right  + dX;
        FCutOutRatioRect.Bottom := FMouseDown_CutOutRatioRect.Bottom + dY;
      end
      else if Shape_CutOut.Tag = 1 then /////////////////////
      begin
        NewCutOutRect.Left   := FMouseDown_CutOutRatioRect.Left + dX;
        NewCutOutRect.Top    := FMouseDown_CutOutRatioRect.Top  + dY;
        NewCutOutRect.Right  := FMouseDown_CutOutRatioRect.Right;
        NewCutOutRect.Bottom := FMouseDown_CutOutRatioRect.Bottom;

        if NewCutOutRect.Left < -1 then
          NewCutOutRect.Left := -1;
        if NewCutOutRect.Top < -1 then
          NewCutOutRect.Top := -1;

        if(NewCutOutRect.Right - NewCutOutRect.Left) < MIN_SIZE then
          NewCutOutRect.Left := NewCutOutRect.Right - MIN_SIZE;
        if(NewCutOutRect.Bottom - NewCutOutRect.Top) < MIN_SIZE then
          NewCutOutRect.Top := NewCutOutRect.Bottom - MIN_SIZE;

        FCutOutRatioRect := NewCutOutRect;
      end
      else if Shape_CutOut.Tag = 3 then /////////////////////
      begin
        NewCutOutRect.Left   := FMouseDown_CutOutRatioRect.Left;
        NewCutOutRect.Top    := FMouseDown_CutOutRatioRect.Top   + dY;
        NewCutOutRect.Right  := FMouseDown_CutOutRatioRect.Right + dX;
        NewCutOutRect.Bottom := FMouseDown_CutOutRatioRect.Bottom;

        if NewCutOutRect.Right > 1 then
          NewCutOutRect.Right := 1;
        if NewCutOutRect.Top < -1 then
          NewCutOutRect.Top := -1;

        if(NewCutOutRect.Right - NewCutOutRect.Left) < MIN_SIZE then
          NewCutOutRect.Right := NewCutOutRect.Left + MIN_SIZE;
        if(NewCutOutRect.Bottom - NewCutOutRect.Top) < MIN_SIZE then
          NewCutOutRect.Top := NewCutOutRect.Bottom - MIN_SIZE;

        FCutOutRatioRect := NewCutOutRect;
      end
      else if Shape_CutOut.Tag = 5 then /////////////////////
      begin
        NewCutOutRect.Left   := FMouseDown_CutOutRatioRect.Left;
        NewCutOutRect.Top    := FMouseDown_CutOutRatioRect.Top;
        NewCutOutRect.Right  := FMouseDown_CutOutRatioRect.Right  + dX;
        NewCutOutRect.Bottom := FMouseDown_CutOutRatioRect.Bottom + dY;

        if NewCutOutRect.Right > 1 then
          NewCutOutRect.Right := 1;
        if NewCutOutRect.Bottom > 1 then
          NewCutOutRect.Bottom := 1;

        if (NewCutOutRect.Right - NewCutOutRect.Left) < MIN_SIZE then
          NewCutOutRect.Right := NewCutOutRect.Left + MIN_SIZE;
        if (NewCutOutRect.Bottom - NewCutOutRect.Top) < MIN_SIZE then
          NewCutOutRect.Bottom := NewCutOutRect.Top + MIN_SIZE;

        FCutOutRatioRect := NewCutOutRect;
      end
      else if Shape_CutOut.Tag = 7 then /////////////////////
      begin
        NewCutOutRect.Left   := FMouseDown_CutOutRatioRect.Left   + dX;
        NewCutOutRect.Top    := FMouseDown_CutOutRatioRect.Top;
        NewCutOutRect.Right  := FMouseDown_CutOutRatioRect.Right;
        NewCutOutRect.Bottom := FMouseDown_CutOutRatioRect.Bottom + dY;

        if NewCutOutRect.Left < -1 then
          NewCutOutRect.Left := -1;
        if NewCutOutRect.Bottom > 1 then
          NewCutOutRect.Bottom := 1;

        if (NewCutOutRect.Right - NewCutOutRect.Left) < MIN_SIZE then
          NewCutOutRect.Left := NewCutOutRect.Right - MIN_SIZE;
        if (NewCutOutRect.Bottom - NewCutOutRect.Top) < MIN_SIZE then
          NewCutOutRect.Bottom := NewCutOutRect.Top + MIN_SIZE;

        FCutOutRatioRect := NewCutOutRect;
      end;

      // 切取り枠の位置を更新するために再描画をかける
      PaintBoxSrc.Repaint;
    end;
  end;
end;

procedure TForm1.Shape_CutOutMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Shape_CutOut.Cursor := crDefault;
end;

procedure TForm1.ActionMakeExecute(Sender: TObject);
var
  EffectIndex: Integer;
var
  BmpSize: TSize;
  CutOutRect: TRect;
  CutOutSize: TSize;
  MakeSize: TSize;

  function _CalcMakeSize: TSize;
  begin
    // Dstが非表示だと、PaintBoxDstの自動サイズ調整がされず、
    // 画面の表示サイズを計算できないようです
    if PageControl1.ActivePage <> TabSheetDst then
    begin
      TabSheetDst.Show;
      PaintBoxDst.AdjustSize;
    end;

    // 画像処理するビットマップの大きさを計算します
    // このサンプルコードでは画面表示のサイズ（プレビューサイズ）
    // を CalcDrawRect で計算しています。
    with CalcDrawRect(PaintBoxDst.ClientRect, CutOutRect) do
    begin
      Result.cx := Right - Left;
      Result.cy := Bottom - Top;
    end;
  end;
begin
  FDstBitmap.Clear;

  // 元画像から切出す領域を計算する
  if Shape_CutOut.Visible and ActionSelectAreaFree.Checked then
  begin
    // 切出し領域の指定あり
    BmpSize := FSrcBitmap.Size;
    CutOutRect.Left   := Round(BmpSize.cx * (1 + FCutOutRatioRect.Left) / 2);
    CutOutRect.Top    := Round(BmpSize.cy * (1 + FCutOutRatioRect.Top) / 2);
    CutOutRect.Right  := Round(BmpSize.cx * (1 + FCutOutRatioRect.Right) / 2);
    CutOutRect.Bottom := Round(BmpSize.cy * (1 + FCutOutRatioRect.Bottom) / 2);
  end
  else
    CutOutRect := FSrcBitmap.Rect;

  CutOutSize.cx := CutOutRect.Right - CutOutRect.Left;
  CutOutSize.cy := CutOutRect.Bottom - CutOutRect.Top;

  if(CutOutSize.cx > 0)and(CutOutSize.cy > 0)then
  begin
    // 画像処理するビットマップの大きさを計算します
    // このサンプルコードでは画面表示のサイズ（プレビューサイズ）にしています
    MakeSize := _CalcMakeSize;

    FDstBitmap.CreateNew(MakeSize.cx, MakeSize.cy);
    FDstBitmap.PaintFrom(FSrcBitmap.Canvas, CutOutRect);

    // 呼出し元の TAction.Tag の値で画像処理のタイプを選択する
    // （メニュー項目に設定したActionのTagプロパティで画像処理を選択）
    if Sender is TAction then
      EffectIndex := TAction(Sender).Tag
    else
      EffectIndex := 0;

    DoEffect(EffectIndex);
  end;
end;

procedure TForm1.DoEffect(EffectIndex: Integer);
begin
  // ダイアログの表示前に、WM_USERメッセージをポストして、
  // メッセージハンドラ（WM_USERの処理）の中で画像処理を行うことで、
  // ダイアログを表示した状態で画像処理を実行します。
  PostMessage(Handle, WM_USER + 0, EffectIndex, 0);
  CancelDlgUnit.CancelDlg.ShowModal;

  TabSheetDst.Show;
  PaintBoxDst.Invalidate;

  // ダイアログが閉じた理由が、正常終了か、キャンセルボタンの押下か、
  // ダイアログの ModalResultプロパティで判定する
  case CancelDlgUnit.CancelDlg.ModalResult of
  mrOk: ;// ShowMessage('正常終了');
  mrCancel: ShowMessage('キャンセルされました');
  mrIgnore: ShowMessage('その画像処理は実装されていません');
  else ShowMessage('原因不明の終了');
  end;
end;

procedure TForm1.WMUser_0(var Message: TMessage);
var
  EffectIndex: Integer;
begin
  EffectIndex := Message.wParam;
  case EffectIndex of
  1: DoEffect_Nothing();
  2: DoEffect_Monochrome();
  3: DoEffect_Negative();
  4: DoEffect_Rigid();
  6: DoEffect_Gunya();
  else CancelDlg.ModalResult := mrIgnore;
  end;
end;

procedure TForm1.DoEffect_Nothing;
begin
  // 何も画像処理はしないで終了する
  // （画像処理の進行状況を表示するダイアログを閉じる）
  CancelDlg.ModalResult := mrOk;
end;

procedure TForm1.DoEffect_Monochrome;
var
  X, Y: Integer;
  Pix: Windows.TRGBQuad;
  Avg: BYTE;
  // P: Windows.PRGBQuad;
begin
  for Y := 0 to FDstBitmap.Height - 1 do
  begin
    // 処理速度を追求する場合は ScanLineプロパティの利用をお勧めします
    // P := FDstBitmap.ScanLine[Y];

    for X := 0 to FDstBitmap.Width - 1 do
    begin
      // 白黒化する
      Pix := FDstBitmap.Pixel[X, Y]^;
      Avg := BYTE((Pix.rgbBlue + Pix.rgbGreen + Pix.rgbRed) div 3);
      FDstBitmap.SetPixel(X, Y, Avg, Avg, Avg);

      // Inc(P); // ScanLineプロパティで取得したポインタを次のピクセルに移動
    end;

    // 画像処理の進行状況を表示するダイアログの
    // キャンセルボタンが押されていたら（ModalResult = mrCancel）
    // ループを抜けて（break）画像処理を中断する
    Application.ProcessMessages; // 画像処理を別スレッド化すればこの行は不要
    // Sleep(0); 画像処理を別スレッド化したら、この行を入れることをお勧めします
    if CancelDlg.ModalResult = mrCancel then
      break
    else // if (Y mod 4) = 0 then // 処理速度を追求する場合は間引き更新もあり
      CancelDlg.Update_by_Percent(Y / FDstBitmap.Height);
  end;

  // 画像処理が完了したので ModalResult に mrOk を設定して、
  // 画像処理の進行状況を表示するダイアロを閉じる
  if CancelDlg.ModalResult = mrNone then
    CancelDlg.ModalResult := mrOk;
end;

procedure TForm1.DoEffect_Negative;
var
  X, Y: Integer;
  Pix: Windows.TRGBQuad;
  // P: Windows.PRGBQuad;
begin
  for Y := 0 to FDstBitmap.Height - 1 do
  begin
    // 処理速度を追求する場合は ScanLineプロパティの利用をお勧めします
    // P := FDstBitmap.ScanLine[Y];

    for X := 0 to FDstBitmap.Width - 1 do
    begin
      // 色を反転する
      Pix := FDstBitmap.Pixel[X, Y]^;
      FDstBitmap.SetPixel(X, Y,
        not Pix.rgbRed, not Pix.rgbGreen, not Pix.rgbBlue);

      // Inc(P); // ScanLineプロパティで取得したポインタを次のピクセルに移動
    end;

    // 画像処理の進行状況を表示するダイアログの
    // キャンセルボタンが押されていたら（ModalResult = mrCancel）
    // ループを抜けて（break）画像処理を中断する
    Application.ProcessMessages; // 画像処理を別スレッド化すればこの行は不要
    // Sleep(0); 画像処理を別スレッド化したら、この行を入れることをお勧めします
    if CancelDlg.ModalResult = mrCancel then
      break
    else // if (Y mod 4) = 0 then // 処理速度を追求する場合は間引き更新もあり
      CancelDlg.Update_by_Percent(Y / FDstBitmap.Height);
  end;

  // 画像処理が完了したので ModalResult に mrOk を設定して、
  // 画像処理の進行状況を表示するダイアロを閉じる
  if CancelDlg.ModalResult = mrNone then
    CancelDlg.ModalResult := mrOk;
end;

procedure TForm1.DoEffect_Rigid;
var
  Bmp: TBitmap32;
  I, B, G, R, T, X, Y: Integer;
  function _Calc(X, Y: Integer): Integer; inline;
  begin
    if(X = 0)and(Y = 0)then
      Result := 0
    else
    begin
      if X > Y then
        Result := $23 - (X * 7 + Y * Y * 3 div X)
      else
        Result := $23 - (Y * 7 + X * X * 3 div Y);
    end;
  end;
  procedure _Scan(CX, CY: Integer);
  var
    X, Y, X1, X2, Y1, Y2: Integer;
  begin
    X1 := CX - 4;
    X2 := CX + 4;
    Y1 := CY - 4;
    Y2 := CY + 4;
    if X1 < 0 then X1 := 0;
    if X2 > (Bmp.Width - 1) then X2 := Bmp.Width - 1;
    if Y1 < 0 then Y1 := 0;
    if Y2 > (Bmp.Height - 1) then Y2 := Bmp.Height - 1;
    for Y := Y1 to Y2 do
    for X := X1 to X2 do
    begin
      I := _Calc(Abs(X - CX), Abs(Y - CY));
      if I > 0 then
      with Bmp.Pixel[X, Y]^ do
      begin
        Inc(B, rgbBlue  * I);
        Inc(G, rgbGreen * I);
        Inc(R, rgbRed   * I);
        Inc(T, I);
      end;
    end;
    R := R div T;
    G := G div T;
    B := B div T;
  end;
  function _Proc(B1, B2: BYTE): BYTE; inline;
  var
    Sff: Integer;
  begin
    Sff := $ff;
    if B1 > B2 then
      Result := (B1 * 2 - B2) * Sff div (Sff + B1 - B2)
    else if B1 < B2 then
      Result := B1 * Sff div (Sff + B2 - B1)
    else
      Result := B1;
  end;
begin
  Bmp := FDstBitmap.Duplicate;
  try
    for Y := 0 to FDstBitmap.Height - 1 do
    begin
      for X := 0 to FDstBitmap.Width - 1 do
      begin
        B := 0;
        G := 0;
        R := 0;
        T := 0;
        _Scan(X, Y);
        with FDstBitmap.Pixel[X, Y]^ do
        FDstBitmap.SetPixel(X, Y,
          _Proc(rgbRed, R), _Proc(rgbGreen, G), _Proc(rgbBlue, B));
      end;

      // 画像処理の進行状況を表示するダイアログの
      // キャンセルボタンが押されていたら（ModalResult = mrCancel）
      // ループを抜けて（break）画像処理を中断する
      Application.ProcessMessages; // 画像処理を別スレッド化すればこの行は不要
      // Sleep(0); 画像処理を別スレッド化したら、この行を入れることをお勧めします
      if CancelDlg.ModalResult = mrCancel then
        break
      else // if (Y mod 4) = 0 then // 処理速度を追求する場合は間引き更新もあり
        CancelDlg.Update_by_Percent(Y / FDstBitmap.Height);
    end;
  finally
    Bmp.Free;
  end;

  // 画像処理が完了したので ModalResult に mrOk を設定して、
  // 画像処理の進行状況を表示するダイアロを閉じる
  if CancelDlg.ModalResult = mrNone then
    CancelDlg.ModalResult := mrOk;
end;

procedure TForm1.DoEffect_Gunya;
var
  TmpBitmap: TBitmap32;
  W, H, X, Y: Integer;
  E, EX, EY: Extended;
  EX2, EY2: Extended;
  X2, Y2: Integer;
begin
  TmpBitmap := FDstBitmap.Duplicate;
  try
    H := FDstBitmap.Height;
    W := FDstBitmap.Width;
    for Y := 0 to H - 1 do
    begin
      EY := (H - Y * 2 - 1)/(H - 1);
      for X := 0 to W - 1 do
      begin
        EX := (W - X * 2 - 1)/(W - 1);
        if Abs(EX) > Abs(EY) then E := Abs(EX)
        else E := Abs(EY);
        EX2 := (EX * 4 - EY * 3) / 5;
        EY2 := (EX * 3 + EY * 4) /5;
        X2 := Round((X * E) + ((W - 1)*(1 - EX2) / 2) * (1 - E));
        Y2 := Round((Y * E) + ((H - 1)*(1 - EY2) / 2) * (1 - E));
        if(X2 >= 0)and(X2 < W)and(Y2 >= 0)and(Y2 < H)then
        FDstBitmap.GetPixel(X, Y)^ := TmpBitmap.GetPixel(X2, Y2)^;
      end;

      // 画像処理の進行状況を表示するダイアログの
      // キャンセルボタンが押されていたら（ModalResult = mrCancel）
      // ループを抜けて（break）画像処理を中断する
      Application.ProcessMessages; // 画像処理を別スレッド化すればこの行は不要
      // Sleep(0); 画像処理を別スレッド化したら、この行を入れることをお勧めします
      if CancelDlg.ModalResult = mrCancel then
        break
      else // if (Y mod 4) = 0 then // 処理速度を追求する場合は間引き更新もあり
        CancelDlg.Update_by_Percent(Y / FDstBitmap.Height);
    end;

  finally
    TmpBitmap.Free;
  end;

  // 画像処理が完了したので ModalResult に mrOk を設定して、
  // 画像処理の進行状況を表示するダイアロを閉じる
  if CancelDlg.ModalResult = mrNone then
    CancelDlg.ModalResult := mrOk;
end;

procedure TForm1.DoDarkFrame(Bitmap: TBitmap32);
var
  W, H, X, Y: Integer;
  E, EX, EY: Extended;
begin
  H := Bitmap.Height;
  W := Bitmap.Width;
  for Y := 0 to H - 1 do
  begin
    EY := 1 - Abs(H - Y * 2 - 1)/(H - 1);
    for X := 0 to W - 1 do
    begin
      EX := 1 - Abs(W - X * 2 - 1)/(W - 1);
      E := 0.2 + Power(EX * EY, 0.4) * 0.8;
      with Bitmap.GetPixel(X, Y)^ do
      begin
        rgbBlue  := Round(rgbBlue  * E);
        rgbGreen := Round(rgbGreen * E);
        rgbRed   := Round(rgbRed   * E);
      end;
    end;
  end;
end;

procedure TForm1.DoWhiteFrame(Bitmap: TBitmap32);
var
  W, H, X, Y: Integer;
  E, EX, EY: Extended;
begin
  H := Bitmap.Height;
  W := Bitmap.Width;
  for Y := 0 to H - 1 do
  begin
    EY := 1 - Abs(H - Y * 2 - 1)/(H - 1);
    for X := 0 to W - 1 do
    begin
      EX := 1 - Abs(W - X * 2 - 1)/(W - 1);
      E := Power(EX * EY, 0.25);
      with Bitmap.GetPixel(X, Y)^ do
      begin
        rgbBlue  := $ff xor Round(($ff xor rgbBlue)  * E);
        rgbGreen := $ff xor Round(($ff xor rgbGreen) * E);
        rgbRed   := $ff xor Round(($ff xor rgbRed)   * E);
      end;
    end;
  end;
end;

end.

